<html>
<head>
<title>Config World Climate widget</title>
</head>
<body>
<h1>Config World Climate widget</h1>

<?

/* Written by Bernd Herd, http://www.herdsoft.com/ 2012.
 *
 * This is Free Software licensed under The GNU General Public License
 * Version 2. See attached file COPYING for details.
 */

// Find language to use for strings
if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE']))
{
  $languages = explode( ',', $_SERVER['HTTP_ACCEPT_LANGUAGE'] );
  //$languages = array( $_SERVER['HTTP_ACCEPT_LANGUAGE'] );
  for ($i = 0; $i<count($languages) && !isset($lang); $i++)
    {
      $l = $languages[$i];
      if (strlen($l) < 100 &&
          substr($l, 0, 2)=='de')
        {
          $lang='de';
        }
      else if (strlen($l) < 100 &&
               substr($l, 0, 2)=='en')
        {
          $lang='en';
        }
    }
}

$total_width =
   isset($_GET['width']) &&
   is_numeric($_GET['width'])
   ? $_GET['width'] : 640;

$total_height =
   isset($_GET['height']) &&
   is_numeric($_GET['height'])
   ? $_GET['height'] : 480;

$widget_title =
  isset($_GET['title']) && strlen($_GET['title'])<100
  ? $_GET['title']
  : ($lang=='de' ? 'Weltklima-Widget' : 'World climate Widget');

$widget_temp_axis =
  isset($_GET['temp_axis']) && strlen($_GET['temp_axis'])<100
  ? $_GET['temp_axis']
  : ($lang=='de' ? 'Temperaturabweichung (C)' : 'Temperature Anomaly (C)');

$widget_co2_axis =
  isset($_GET['co2_axis']) && strlen($_GET['co2_axis'])<100
  ? $_GET['co2_axis']
  : ($lang=='de' ? 'CO2 Konzentration (ppm)' : 'CO2 Concentration (ppm)');

$widget_start_year =
  isset($_GET['start_year']) &&
  is_numeric($_GET['start_year'])
  ? $_GET['start_year']
  : 1950;

$widget_alias =
  isset($_GET['alias']) &&
  is_numeric($_GET['alias'])
  ? $_GET['alias']
  : 2;

if ($widget_alias < 1) $widget_alias=1;
if ($widget_alias > 4) $widget_alias=4;

$temp_rgb =
  isset($_GET['temp_rgb']) &&
  strlen($_GET['temp_rgb'])==6
  ? $_GET['temp_rgb']
  : "b2b2b2";

$co2_rgb =
  isset($_GET['co2_rgb']) &&
  strlen($_GET['co2_rgb'])==6
  ? $_GET['co2_rgb']
  : "1786ec";

$ice_rgb =
  isset($_GET['ice_rgb']) &&
  strlen($_GET['ice_rgb'])==6
  ? $_GET['ice_rgb']
  : "178600";

?>


<form method="get" action="config.php">
<table>
<tr>

  <td>Width</td>
  <td><input name="width" size="5" value="<? echo $total_width; ?>"></td>

</tr>

<tr>

  <td>Height</td>
  <td><input name="height" size="5" value="<? echo $total_height; ?>"></td>

</tr>

<tr>

  <td>Start-Year</td>
  <td><input name="start_year" size="5" value="<? echo $widget_start_year; ?>"></td>

</tr>


<tr>

  <td>Widget title</td>
  <td><input name="title" size="100" value="<? echo htmlentities($widget_title); ?>"></td>

</tr>


<tr>

  <td>Temperature-Axis description</td>
  <td><input name="temp_axis" size="100" value="<? echo htmlentities($widget_temp_axis); ?>"></td>

</tr>


<tr>

  <td>CO2 description</td>
  <td><input name="co2_axis" size="100" value="<? echo htmlentities($widget_co2_axis); ?>"></td>

</tr>

<tr>

  <td>Color for Temperature Curve</td>
  <td><select name="temp_rgb">
        <option value="b2b2b2" <? if ($temp_rgb=="b2b2b2") echo "selected"; ?> >Gray</option>
        <option value="1786ec" <? if ($temp_rgb=="1786ec") echo "selected"; ?> >Blue</option>
        <option value="b21010" <? if ($temp_rgb=="b21010") echo "selected"; ?> >Red</option>
        <option value="00ff00" <? if ($temp_rgb=="00ff00") echo "selected"; ?> >Green</option>
        <option value="000000" <? if ($temp_rgb=="000000") echo "selected"; ?> >Black</option>
      </select>
  </td>

</tr>


<tr>

  <td>Color for CO2 Concentration</td>
  <td><select name="co2_rgb">
        <option value="b2b2b2" <? if ($co2_rgb=="b2b2b2") echo "selected"; ?> >Gray</option>
        <option value="1786ec" <? if ($co2_rgb=="1786ec") echo "selected"; ?> >Blue</option>
        <option value="b21010" <? if ($co2_rgb=="b21010") echo "selected"; ?> >Red</option>
        <option value="00ff00" <? if ($co2_rgb=="00ff00") echo "selected"; ?> >Green</option>
        <option value="000000" <? if ($co2_rgb=="000000") echo "selected"; ?> >Black</option>
      </select>
  </td>

</tr>


<tr>

  <td>Color for Icecore Data CO2 Concentration</td>
  <td><select name="ice_rgb">
        <option value="b2b2b2" <? if ($ice_rgb=="b2b2b2") echo "selected"; ?> >Gray</option>
        <option value="1786ec" <? if ($ice_rgb=="1786ec") echo "selected"; ?> >Blue</option>
        <option value="b21010" <? if ($ice_rgb=="b21010") echo "selected"; ?> >Red</option>
        <option value="178600" <? if ($ice_rgb=="178600") echo "selected"; ?> >Green</option>
        <option value="000000" <? if ($ice_rgb=="000000") echo "selected"; ?> >Black</option>
      </select>
  </td>

</tr>


<tr>

  <td>Anti-Aliasing</td>
  <td><select name="alias">
        <option value="1" <? if ($widget_alias=="1") echo "selected"; ?> >None (Transparent)</option>
        <option value="2" <? if ($widget_alias=="2") echo "selected"; ?> >Normal</option>
        <option value="4" <? if ($widget_alias=="4") echo "selected"; ?> >Strong</option>
      </select>
  </td>

</tr>

</table>

<input type="submit">

</form>

<?php

$object = "";

if ($total_width != 640)
{
   $object = $object . "&width=$total_width";
}

if ($total_height != 480)
{
   $object = $object . "&height=$total_height";
}

if ($widget_title != "Weltklima-Widget" &&
    $widget_title != "World climate Widget")
{
   $object = $object . "&title=" . urlencode($widget_title);
}

if ($widget_temp_axis != "Temperaturabweichung (C)" &&
    $widget_temp_axis != "Temperature Anomaly (C)")
{
   $object = $object . "&temp_axis=" . urlencode($widget_temp_axis);
}

if ($widget_co2_axis != "CO2 Konzentration (ppm)" &&
    $widget_co2_axis != "CO2 Concentration (ppm)")
{
   $object = $object . "&co2_axis=" . urlencode($widget_co2_axis);
}

if ($widget_start_year!=1950)
{
   $object = $object . "&start_year=$widget_start_year";
}

if ($widget_alias!=2)
{
   $object = $object . "&alias=$widget_alias";
}


if ($temp_rgb!="b2b2b2")
{
   $object = $object . "&temp_rgb=$temp_rgb";
}

if ($co2_rgb!="1786ec")
{
   $object = $object . "&co2_rgb=$co2_rgb";
}

if ($ice_rgb!="178600")
{
   $object = $object . "&ice_rgb=$ice_rgb";
}

if (strlen($object)>1)
{
   $object = "image.php?" . substr($object, 1);
}
else
{
   $object = "image.php";
}

echo "<p><img src=\"$object\" width=\"$total_width\" height=\"$total_height\"></p>";
//echo "<table><tr><td style=\"background-image:url(irene.png)\"><img src=\"$object\" width=\"$total_width\" height=\"$total_height\"></td></tr></table>";


if ( isset($_SERVER['SERVER_NAME']) )
{
  $pos = strrpos($_SERVER['PHP_SELF'], "/");
  $sst = substr($_SERVER['PHP_SELF'], 0, $pos);

  $url = "http://" . $_SERVER['SERVER_NAME'] . "$sst/" . $object;

  echo "<p>Permalink: <a href=\"" . htmlentities($url) . "\">" . htmlentities($url) . "</a></p>\n";


  echo "<h1>HTML Code</h1>\n";
  echo "<p>To add this widget to your Site, add the following HTML code:</p>\n";
  
  $code = "<img src=\"$url\" width=\"$total_width\" height=\"$total_height\">";
  echo "<p><b>" . htmlentities($code) . "</b></p>";

}


?>

<h1>Scientific Background</h1>

<p>This widget is inspired by a 
<a href="http://www.scilogs.de/wblogs/blog/klimalounge/klimadaten/2012-09-27/die-populaerste-trickgrafik-der-klimaskeptiker-vahrenholt">post</a>
by the Scientist Stefan Rahmstorf in the german 
<a href="http://www.scilogs.de/wblogs/blog/klimalounge/">Klimalounge</a> Blog.

It illustrates the correlation of observed global mean temperature
anomalies with increasing CO2 and changes in the number of sun spots.
</p>

<p>Please read the <a href="http://www.scilogs.de/wblogs/blog/klimalounge/klimadaten/2012-09-27/die-populaerste-trickgrafik-der-klimaskeptiker-vahrenholt">blog post</a>
for more information on the scientific background. More References:</p>
<ul>
<li><a href="http://www.realclimate.org/index.php/archives/2014/12/the-most-popular-deceptive-climate-graph/">Article on Realclimate.org</a></li>
<li><a href="http://dotearth.blogs.nytimes.com/2014/12/08/warming-trend-and-variations-on-a-greenhouse-heated-planet/">Article in New York Times</a></li>
</ul>

<h2>Data Sources</h2>

<ul>
<li>Global mean temperatures are from: <a href="http://data.giss.nasa.gov/gistemp/tabledata_v3/GLB.Ts+dSST.txt">http://data.giss.nasa.gov/gistemp/tabledata_v3/GLB.Ts+dSST.txt</a></li>
<li>Average number of sun spots per year are from: <a href="http://sidc.oma.be/DATA/yearssn.dat">http://sidc.oma.be/DATA/yearssn.dat</a></li>
<li>Exact CO2 measurements are from: <a href="ftp://ftp.cmdl.noaa.gov/ccg/co2/trends/co2_annmean_mlo.txt">ftp://ftp.cmdl.noaa.gov/ccg/co2/trends/co2_annmean_mlo.txt</a></li>
<li>CO2 Data from the Law Dome ice core, Antarctica.
Reference:
Etheridge, D.M., L.P. Steele, R.L. Langenfelds, R.J. Francey, J.-M. 
Barnola, and V.I. Morgan. 1996.
Natural and anthropogenic changes in atmospheric CO2 over the last 1000 
years
from air in Antarctic ice and firn.
Journal of Geophysical Research 101:4115-4128.
    <a href="http://cdiac.ornl.gov/ftp/trends/co2/lawdome.smoothed.yr20">http://cdiac.ornl.gov/ftp/trends/co2/lawdome.smoothed.yr20</a></li>
</ul>

<p>A cron job updates them once a month.</p>


<h1>Software</h1>
<p>The Plotting Software is written by Bernd Herd, http://www.herdsoft.com/.
It is Free Software licensed unter GPLv2.</p>

<p><a href="widget.zip">Download</a></p>

<h1>More climate data</h1>

<ul>
<li><a href="http://www.dwd.de/klimaatlas">Deutscher Klimaatlas</a></li>
<li><a href="http://www.woodfortrees.org/">woodfortrees.org</a></li>
</ul>

</body>
</html>